> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.ibee.co.in/docs/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.ibee.co.in/docs/_mcp/server.

# Create a VPC

POST https://api.ibee.co.in/v1/networking/vpcs
Content-Type: application/json

Creates an isolated virtual network. Requires scope: network.write.

Reference: https://docs.ibee.co.in/docs/api-reference/vpcs/create-vpc

## Authentication

- `Authorization` header (bearer token, required) — IBEE platform API token. Production tokens start with `ibee_prod_key_`; development tokens start with `ibee_dev_key_`. Use a token only with its matching gateway environment.

## Servers

- `https://api.ibee.co.in/v1` (Production, default)
- `https://api.ibee.co.in/v1` (Development)

## Request

### Query parameters

- `workspace_id` (string, required) — The positive numeric workspace ID to scope this request to. Zero, negative, and non-numeric values are rejected.

### Body (application/json)

This endpoint expects a CreateVpcRequest.

- `name` (string, required)
- `site_id` (string, required) — Required network placement site. Copy `site_id` from `GET /networking/sites` and choose an entry where `available` is `true`. Do not use a region name.
- `description` (string, optional, default: )
- `region` (string, optional, nullable)
- `cidr` (string, optional, nullable) — RFC1918 IPv4 CIDR with a prefix between /22 and /28.
- `auto_cidr` (boolean, optional, default: true)
- `create_default_subnet` (boolean, optional, default: true)
- `default_subnet_cidr` (string, optional, nullable)
- `is_default` (boolean, optional, default: false)
- `connectivity_type` (enum, optional, default: public)
  - Allowed values: `public`, `nat_gateway`

## Response

### 201

VPC created successfully.

- `vpc_id` (string, required)
- `organization_id` (string, required)
- `workspace_id` (string, required)
- `site_id` (string, required)
- `name` (string, required)
- `cidr` (string, required)
- `status` (enum, required)
  - Allowed values: `provisioning`, `available`, `error`, `deleting`
- `connectivity_type` (enum, required)
  - Allowed values: `public`, `nat_gateway`
- `created_at` (datetime, required)
- `updated_at` (datetime, required)
- `account_id` (string, optional)
- `description` (string, optional)
- `region` (string, optional, nullable)
- `is_default` (boolean, optional)
- `error_message` (string, optional, nullable)
- `node_count` (integer, optional)
- `nat_pricing` (NatPricing, optional)
- `subnets` (list of Subnet, optional)
- `nat_gateways` (list of NatGateway, optional)
- `attached_nodes` (list of VpcAttachedNode, optional)

## Errors

### 400 Bad Request Error

The request is invalid.

- `detail` (ErrorDetail, optional)

### 401 Unauthorized Error

The API token is missing or invalid.

- `detail` (ErrorDetail, optional)

### 403 Forbidden Error

The token is not allowed to access the workspace or does not have the required scope.

- `detail` (ErrorDetail, optional)

### 409 Conflict Error

The request conflicts with the current resource state.

- `detail` (ErrorDetail, optional)

## Types

### NatPricing

- `currency` (string, optional, default: USD)
- `price_per_hour` (double, optional, default: 0)
- `data_price_per_gb` (double, optional, default: 0)
- `billing_enforced` (boolean, optional, default: false)

### Subnet

- `subnet_id` (string, required)
- `vpc_id` (string, required)
- `site_id` (string, required)
- `name` (string, required)
- `cidr` (string, required)
- `gateway` (string, required)
- `dns` (list of string, required)
- `status` (enum, required)
  - Allowed values: `provisioning`, `available`, `error`, `deleting`
- `created_at` (datetime, required)
- `updated_at` (datetime, required)
- `organization_id` (string, optional)
- `workspace_id` (string, optional)
- `error_message` (string, optional, nullable)

### NatGateway

- `nat_gateway_id` (string, required)
- `vpc_id` (string, required)
- `site_id` (string, required)
- `name` (string, required)
- `public_ip_id` (string, required)
- `public_ip` (string, required)
- `status` (enum, required)
  - Allowed values: `provisioning`, `available`, `error`, `deleting`
- `subnet_id` (string, optional, nullable)
- `organization_id` (string, optional)
- `workspace_id` (string, optional)
- `pricing` (NatPricing, optional)
- `error_message` (string, optional, nullable)

### VpcAttachedNode

- `allocation_id` (string, optional)
- `vm_id` (string, optional)
- `subnet_id` (string, optional)
- `private_ip` (string, optional)
- `connectivity` (enum, optional)
  - Allowed values: `private`, `public_ip`, `nat`
- `public_ip` (string, optional, nullable)
- `nat_public_ip` (string, optional, nullable)
- `status` (string, optional)
- `attached_at` (datetime, optional)

### ErrorDetail

## Examples

**Request**

```json
{
  "name": "string",
  "site_id": "68b99bd78a8eda32ff3f16ea"
}
```

**Response**

```json
{
  "vpc_id": "string",
  "organization_id": "string",
  "workspace_id": "string",
  "site_id": "string",
  "name": "string",
  "cidr": "string",
  "status": "provisioning",
  "connectivity_type": "public",
  "created_at": "2024-01-15T09:30:00Z",
  "updated_at": "2024-01-15T09:30:00Z",
  "account_id": "string",
  "description": "string",
  "region": "string",
  "is_default": true,
  "error_message": "string",
  "node_count": 1,
  "nat_pricing": {
    "currency": "USD",
    "price_per_hour": 0,
    "data_price_per_gb": 0,
    "billing_enforced": false
  },
  "subnets": [
    {
      "subnet_id": "string",
      "vpc_id": "string",
      "site_id": "string",
      "name": "string",
      "cidr": "string",
      "gateway": "string",
      "dns": [
        "string"
      ],
      "status": "provisioning",
      "created_at": "2024-01-15T09:30:00Z",
      "updated_at": "2024-01-15T09:30:00Z",
      "organization_id": "string",
      "workspace_id": "string",
      "error_message": "string"
    }
  ],
  "nat_gateways": [
    {
      "nat_gateway_id": "string",
      "vpc_id": "string",
      "site_id": "string",
      "name": "string",
      "public_ip_id": "string",
      "public_ip": "string",
      "status": "provisioning",
      "subnet_id": "string",
      "organization_id": "string",
      "workspace_id": "string",
      "pricing": {
        "currency": "USD",
        "price_per_hour": 0,
        "data_price_per_gb": 0,
        "billing_enforced": false
      },
      "error_message": "string"
    }
  ],
  "attached_nodes": [
    {
      "allocation_id": "string",
      "vm_id": "string",
      "subnet_id": "string",
      "private_ip": "string",
      "connectivity": "private",
      "public_ip": "string",
      "nat_public_ip": "string",
      "status": "string",
      "attached_at": "2024-01-15T09:30:00Z"
    }
  ]
}
```

**SDK Code**

```python
import requests

url = "https://api.ibee.co.in/v1/networking/vpcs"

querystring = {"workspace_id":"710995"}

payload = {
    "name": "string",
    "site_id": "68b99bd78a8eda32ff3f16ea"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"name":"string","site_id":"68b99bd78a8eda32ff3f16ea"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995"

	payload := strings.NewReader("{\n  \"name\": \"string\",\n  \"site_id\": \"68b99bd78a8eda32ff3f16ea\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"string\",\n  \"site_id\": \"68b99bd78a8eda32ff3f16ea\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"string\",\n  \"site_id\": \"68b99bd78a8eda32ff3f16ea\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995', [
  'body' => '{
  "name": "string",
  "site_id": "68b99bd78a8eda32ff3f16ea"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"string\",\n  \"site_id\": \"68b99bd78a8eda32ff3f16ea\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "string",
  "site_id": "68b99bd78a8eda32ff3f16ea"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.ibee.co.in/v1/networking/vpcs?workspace_id=710995")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```